#ifndef __SPINS_H
#define __SPINS_H 1

#include <stdlib.h>	/* Achtung bei long<->int-Mischmasch */
#include <stdio.h>
#include <string.h>	/* strcat, strcmp, usw. */
#include <math.h>
#ifndef M_PI		/* not part of C99 */
#define M_PI           3.14159265358979323846
#endif
/* #include "spinsdef.h" */	/* define Lsize Dsize Isize etc. */
#include "config.h"
#include "sighand.h"	/* signalhandler -> ini_handler, sig1 */
#include "defs.h"
#include "modeldef.h"	/* specialy system */
#include "mem.h"
#include "hilbert.h"  /* thbuf */

// 2016-01 better local for simplicity
//extern int	algo;	/* algorithm 0=lanzcos,1=richter,2=wenzel2x2 */
//extern int	x_p;	/* output format for |x> <=3 */
extern int      chkpt_mode;  /* setup after crash possible old: save_mode */
extern int      checkpoint; /* setup after crash possible */

/* name of the checkpoint file */
#define FCHKPT "tmp/chkpt"

/* set or unset the following macros in config.h and not here
   (here we have only default values) */
/* IFz(x) produced a cpp-error on cray, so we changed it back 1998-148 */
/* ToDo: add PARAz for XXZ model */
#ifndef IFz		/* may be predefined in config.h */
#define IFz	1  	/* 1 = JJ-model, 0 = XY-JJ-model, else XXZ-model */
#endif
#ifndef NEW
#define NEW	4	/* number of lowest eigenvalues   >=NEV,>ne0 */
#endif
#if defined(NEV) && defined(CFG_FTLM) && NEV<MAX_ITR
#error NEV is to small, must be MAX_ITR
#undef NEV
#endif

#ifndef NEV
#ifdef CFG_FTLM  /* support for Finite Temperature Lanczos Method */
#define NEV   MAX_ITR  /* needed to store all tridiag-eigenvectors 2016-05 */
#else
#define NEV	1	/* max. number of eigenvectors  <=(NEW-NE0) */
#endif
#endif

#ifndef CM			/* CaseModel => config.h */
#error define CM(JJ,tJ,tU) JJ	/* default=JJ else tJ or tU model */
#endif

#ifndef N0
#define N0 NN
#endif

/* tbase moved from spins.h to hilbert.h 2017-01-23 */

#include "symmetry.h"	/* need declaration of tbase1 */


extern ULong  n1,n2;		/* Matrixsize , Lin table size ? */
extern int    n1_bits; /* bits needed to store n1, used for MPI packing */
extern double h_nz;    /* number of nonzero matrix elements (statistics) */
extern int	pew;		/* number eigenvalue to check    */
#ifndef CFG_FTLM  /* ~ Finite-Temperature Lanczos Method */
extern double ew[NEW];          /* eigenvalues  (max# NEW)       */
#else
extern double ew[MAX_ITR];      /* full tridiag needed */
#endif
extern FILE *f1;		/* output file			 */
extern ULong *base2;
extern ULong h_n1;		/* # of stored lines in hxy (obsolete)	*/
extern ULong hfmax;		/* max. number of hxy-elements on disk	*/
#if 0				/* never defined, better than comments?	*/
 extern cplx sqrt(x)cplx x;{return(pow(x,0.5));}/* only for buggy GNUC	*/
#endif


	/* Flip(cfg,i1,i2) cfg^flip[i1][i2] last change: Apr98 JS */
#if   CM(1,0,0)
#define Flip(cfg,i1,i2) ((cfg) ^ ((tbase)1)<<(i1) ^ ((tbase)1)<<(i2))
#elif CM(0,1,1)				/* u<=>d sites i,j */
#define Flip(cfg,i1,i2) ((cfg) ^ ((tbase)3)<<((i1)*2) ^ ((tbase)3)<<((i2)*2) )
#endif

/* AH NZX VS shbuf from spins.h to h_file.h(matrix-store-defs) 2017-01-23 */

#include "symmetry.h"
static inline double norm(const double r){return(r*r);}
char *sclock(long t);
/* --------------- in-out-functions ---------------------------- */
char *outc(cplx r);  /* complex double */    

void nl(FILE *f);
void outew(FILE *f, const double *ew, const int n_ew); /* "new" = C++keyword */

/* get, store or multiply  H line i..i+nahead-1 (depends on m1) */
cplx hamilton_nhv(ULong i, ULong nahead, thbuf *hbuf, int m1);

/* v1=H*v0+v1, r=<v0|H*v0> */
double hamilton(scplx *v0, scplx *v1, thbuf *hbuf[B_NUM]);

/* void storeh(); --obsolete-- */

/* send job (function worker) to threads and restart them */
void parallel_start( int thread_i, void (*worker)(void *data), void *data );
 
/* waiting for threads OR dummy for non-threaded */
void parallel_wait( int thread_i );

#endif
/* last line should be a newline, else cray-cc prints warnings */

